<?php
namespace Patchouli\Dummy;

use Patchouli\IPackage;
use Patchouli\Version;

class DummyPackage implements IPackage {
    public function getId(): string {
        return 'package-id';
    }

    public function getName(): string {
        return 'Human Readable Name';
    }

    public function getVersion(): Version {
        return new Version('1.2.3-beta1');
    }

    public function getFiles(): array {
        return [
            new DummyPackageFile('filename.bin'),
            new DummyPackageFile('boobs.png'),
        ];
    }

    public function getTargets(): array {
        return [new DummyPackageTarget];
    }

    public function getDependencies(): array {
        return [];
    }

    public function fwifSerialize(): array {
        return [
            'id' => $this->getId(),
            'name' => $this->getName(),
            'version' => $this->getVersion(),
            'files' => $this->getFiles(),
            'targets' => $this->getTargets(),
            'deps' => $this->getDependencies(),
        ];
    }
}
